import es
import playerlib
import random
import gamethread
import soccer.soccer as soccerlib
import nativetools
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Health Script"
info.version = soccerlib.info.version
info.basename = "soccerhealth"
info.author = "chrismrulz"

healthmode = int(soccerlib.config.get("Health", "healthmode"))
disableknives = int(soccerlib.config.get("Health", "disableknives"))
clearbodies = int(soccerlib.config.get("Health", "clearbodies"))
godmode_respawn = int(soccerlib.config.get("Health", "godmode_respawn"))
godmode_re = 0

def load():
  es.msg("#Green", "Soccer Health Script On - by Toph")
  loadblock()

def unload():
  if(healthmode == 3):
    es.unload('soccer/soccerrespawn')
  elif(healthmode == 4):
    es.unload('soccer/soccerrespawn2')
  elif(healthmode == 5):
    es.unload('soccer/soccerrespawn3')
  es.msg("#Green", "Soccer Health Script Off")
  if(disableknives == 1):
    nativetools.preEventUnregister("player_hurt", player_hurt_pre)

def es_map_start(event_var):
  loadblock()

def loadblock():
  if(healthmode == 3):
    es.load('soccer/soccerrespawn')
    es.unload('soccer/soccerhealth')
  elif(healthmode == 4):
    es.load('soccer/soccerrespawn2')
  elif(healthmode == 5):
    es.load('soccer/soccerrespawn3')
  if(disableknives == 1):
    nativetools.preEventRegister("player_hurt", player_hurt_pre)

def player_hurt_pre(event_var):
	if(event_var['weapon'] == 'knife'):
		player = playerlib.getPlayer(nativetools.preEventGetInt('userid'))
		player.setHealth(player.getHealth() + event_var['dmg_health'])
		es.setplayerprop(nativetools.preEventGetInt('userid'), 'CCSPlayer.cslocaldata.m_flVelocityModifier', 1)

def round_start(event_var):
  if(healthmode == 2):
    rp = random.choice(playerlib.getUseridList('#alive'))
    soccerlib.dofire(rp, 'terro_But', 'addoutput \"OnTrigger point_servercommand,command,es_xdoblock soccer/soccerhealth/tgoal\"')
    soccerlib.dofire(rp, 'ct_But', 'addoutput \"OnTrigger point_servercommand,command,es_xdoblock soccer/soccerhealth/ctgoal\"')
    global godmode_re
    godmode_re = 0

def godmode(pfilter, on = 1):
  myPlayerList = playerlib.getUseridList(pfilter)
  for userid in myPlayerList:
    if(on == 1):
      es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 0)
    else:
      es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 512)

def tgoal():
  godmode('#t', 0)
  global godmode_re
  godmode_re = 1

def ctgoal():
  godmode('#ct', 0)
  global godmode_re
  godmode_re = 1

def player_hurt(event_var):
  if(healthmode == 1 or healthmode == 4 or healthmode == 5):
    es.setplayerprop(event_var['userid'], 'CBasePlayer.m_iHealth', 250)

def player_death(event_var):
  gmrs(event_var['userid'])
  if(clearbodies != 0):
    gamethread.delayed(int(clearbodies), es.fire, (event_var['userid'], 'cs_ragdoll kill'))

def player_team(event_var):
  gmrs(event_var['userid'])

def gmrs(uid):
  if(healthmode == 2 and godmode_respawn == 1 and godmode_re == 0):
    nativetools.spawnPlayer(uid)

def player_spawn(event_var):
  if(healthmode == 1 or healthmode == 4 or healthmode == 5):
    es.setplayerprop(event_var['userid'], 'CBasePlayer.m_iHealth', 250)
  elif(healthmode == 2):
    godmode(event_var['userid'])