import es
import playerlib
import soccer.soccer as soccerlib
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Goalie Script"
info.version = soccerlib.info.version
info.basename = "soccergoalie2"
info.author = "chrismrulz"

soccerteamskins_enabled = int(soccerlib.config.get("Core", "soccerteamskins_enabled"))
spawntele = int(soccerlib.config.get("Goalie", "spawntele"))
tgskin = soccerlib.config.get("Goalie", "tgskin")
ctgskin = soccerlib.config.get("Goalie", "ctgskin")
tskin = soccerlib.config.get("Skins", "tskin")
ctskin = soccerlib.config.get("Skins", "ctskin")
soccerlib.adddownloads([tgskin,ctgskin,tskin,ctskin])
goalxm = soccerlib.goalxm
goalxp = soccerlib.goalxp
tgoalym = soccerlib.tgoalym
tgoalyp = soccerlib.tgoalyp
ctgoalym = soccerlib.ctgoalym
ctgoalyp = soccerlib.ctgoalyp
pbx = soccerlib.pbx
pbz = soccerlib.pbz
newpbcty = soccerlib.newpbcty
newpbty = soccerlib.newpbty
tgoalie = 0
ctgoalie = 0

def load():
	es.msg('#Green','Soccer Goalie Script On - by Toph')

def unload():
	es.msg('#Green','Soccer Goalie Script Off')

def telegoalies():
	if(tgoalie != 0):
		playerlib.getPlayer(es.getuserid(tgoalie)).setLocation([pbx, newpbty, pbz])
	if(ctgoalie != 0):
		playerlib.getPlayer(es.getuserid(ctgoalie)).setLocation([pbx, newpbcty, pbz])

def player_hurt(event_var):
	if(event_var['weapon'] == "knife"):
		if(event_var['es_steamid'] == tgoalie):
			kgkx,kgky,kgkz = es.getplayerlocation(event_var['userid'])
			if(kgkx < goalxp and kgky < tgoalyp and kgkx > goalxm and kgky > tgoalym):
				es.msg('#multi', "#greenPlayer#lightgreen %s #greenknifed the terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
		elif(event_var['es_steamid'] == ctgoalie):
			kgkx,kgky,kgkz = es.getplayerlocation(event_var['userid'])
			if(kgkx < goalxp and kgky < ctgoalyp and kgkx > goalxm and kgky > ctgoalym):
				es.msg('#multi',"#greenPlayer#lightgreen %s #greenknifed the counter-terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))

def round_start(event_var):
	if(spawntele == 1):
		telegoalies()

def sharegoalies():
	es.set('ctgoalie', ctgoalie)
	es.set('tgoalie', tgoalie)

def player_changename(event_var):
	steamid = es.getplayersteamid(event_var['userid'])
	if(event_var['es_userteam'] == '2'):
		global tgoalie
		if("<GK>" in event_var['newname']):
			if(tgoalie == 0):
				tgoalie = event_var['es_steamid']
				playerlib.getPlayer(event_var['userid']).setModel(tgskin)
			elif(tgoalie != event_var['es_steamid']):
				es.cexec(event_var['userid'], 'name %s' % event_var['newname'].replace("<GK>", ""))
		elif(tgoalie == steamid):
			tgoalie = 0
			if(soccerteamskins_enabled == 1):
				es.doblock('soccer/soccerteamskins/lo3spawn')
			else:
				playerlib.getPlayer(event_var['userid']).setModel(tskin)
	elif(event_var['es_userteam'] == '3'):
		global ctgoalie
		if("<GK>" in event_var['newname']):
			if(ctgoalie == 0):
				ctgoalie = event_var['es_steamid']
				playerlib.getPlayer(event_var['userid']).setModel(ctgskin)
			elif(ctgoalie != event_var['es_steamid']):
				es.cexec(event_var['userid'], 'name %s' % event_var['newname'].replace("<GK>", ""))
		elif(ctgoalie == steamid):
			ctgoalie = 0
			if(soccerteamskins_enabled == 1):
				es.doblock('soccer/soccerteamskins/lo3spawn')
			else:
				playerlib.getPlayer(event_var['userid']).setModel(ctskin)
	sharegoalies()

def activecheck(steamid):
	global tgoalie
	global ctgoalie
	if(steamid == tgoalie):
		tgoalie = 0
	elif(steamid == ctgoalie):
		ctgoalie = 0

def player_disconnect(event_var):
	activecheck(event_var['networkid'])

def player_death(event_var):
	activecheck(event_var['es_steamid'])

def player_spawn(event_var):
	skinloop(event_var['userid'], event_var['es_steamid'], event_var['es_username'], event_var['es_userteam'])

def lo3spawn():
	if(es.getInt('soccergoalie_enabled') == 2):
		global tgoalie
		global ctgoalie
		tgoalie = 0
		ctgoalie = 0
		for player in playerlib.getPlayerList('#alive'):
			skinloop(player.userid, player.steamid, player.name, player.team)

def skinloop(luserid, lsid, lusername, team):
	if(team == '2'):
		if("<GK>" in lusername):
			global tgoalie
			if(tgoalie == 0):
				tgoalie = lsid
				playerlib.getPlayer(luserid).setModel(tgskin)
			elif(tgoalie == lsid):
				playerlib.getPlayer(luserid).setModel(tgskin)
			else:
				es.cexec(luserid, 'name %s' % lusername.replace("<GK>", ""))
				if(soccerteamskins_enabled != 1):
					playerlib.getPlayer(luserid).setModel(tskin)
		elif(soccerteamskins_enabled != 1):
			playerlib.getPlayer(luserid).setModel(tskin)
	elif(team == '3'):
		if("<GK>" in lusername):
			global ctgoalie
			if(ctgoalie == 0):
				ctgoalie = lsid
				playerlib.getPlayer(luserid).setModel(ctgskin)
			elif(ctgoalie == lsid):
				playerlib.getPlayer(luserid).setModel(ctgskin)
			else:
				es.cexec(luserid, 'name %s' % lusername.replace("<GK>", ""))
				if(soccerteamskins_enabled != 1):
					playerlib.getPlayer(luserid).setModel(ctskin)
		elif(soccerteamskins_enabled != 1):
			playerlib.getPlayer(luserid).setModel(ctskin)
	sharegoalies()